"use strict";

openerp.eiru_reporting = function (instance, local) {
    var QWeb = instance.web.qweb;
    var number= instance.web;
    local.ReportingWidget = instance.Widget.extend({
        template: 'EiruReporting',
        events: {
            'click .report_action > button': 'clickOnReport',
        },
        reports: [
            // {
            //     title: 'Listado de Productos',
            //     description: 'Breve descripción del reporte',
            //     action: 'AllProducts'
            // },
            {
                title: 'Resumen de Ingreso',
                description: 'Resumen de Ingreso(Pagos de  Clientes) ',
                action: 'ReportResumenIngreso'
            },
            {
                title: 'Análisis de Utilidad',
                description: 'Breve descripción del reporte',
                action: 'ReportInvoiceUtility'
            },
            // {
            //     title: 'Análisis de Utilidad de Productos',
            //     description: 'Análisis de Utilidad de producto, Promedia el precio de venta Costo de la cantidad vendida y su la utilidad',
            //     action: 'ReportProductUtility'
            // },
            {
                title: 'Listado de Stock por Ubicacion',
                description: 'Listado de Stock por Sucursal',
                action: 'ReportStockLocation'
            }
            // {
            //     title: 'Análisis de Utilidad',
            //     description: 'Breve descripción del reporte',
            //     action: 'ProductListWidget'
            // },
            // {
            //     title: 'Análisis de Utilidad',
            //     description: 'Breve descripción del reporte',
            //     action: 'ProductListWidget'
            // }
        ],
        start: function () {
        },

        clickOnReport: function (e) {

            var templateName = this.$el.find(e.target).val();
            this.renderReport(templateName);
        },

        renderReport: function (templateName) {
            var Widget = this.getWidgetFromTemplate(templateName);
            var WidgetInstance = new Widget(this);
            var container = this.$el.find('.oe_form_sheet.oe_form_sheet_width');
            container.find('.report_view').hide({
                effect: 'fade',
                duration: 200,
                complete: function () {
                    WidgetInstance.appendTo(container);
                }
            });
        },
        getWidgetFromTemplate: function (templateName) {
            var widgetName = `${templateName}Widget`;
            return _.pick(local, widgetName)[widgetName];
        },
    });

    local.AllProductsWidget = instance.Widget.extend({
        template: 'AllProducts',
        events: {
            'click #toolbar > button': 'clickOnAction',
        },
        products: [],
        fields: ['name', 'code', 'ean13', 'list_price', 'type'],
        domain: [['active', '=', true]],
        init: function (parent) {
            this._super(parent);
        },
        start: function () {
            var self = this;
            this.getProducts().then(function (products) {
                self.products = products;
                self.drawTable(products);
            });
        },
        getProducts: function () {
            var Product = new instance.web.Model('product.product');
            return Product.query(this.fields).filter(this.domain).order_by(['id']).all();
        },
        drawTable: function (products) {
            var table = this.$el.find('#table');
            table.bootstrapTable({
                data: products
            });
        },
        clickOnAction: function (e) {
            var action = this.$el.find(e.target).val();
            var self = this;

            if (action === 'chart') {
                this.$el.find('.bootstrap-table').hide({
                    effect: 'drop',
                    direction: 'up',
                    duration: 200,
                    complete: function () {
                        self.drawChart();
                    }
                });
            }

            if (action === 'pdf') {
                this.drawPdf();
            }
        },
        drawChart: function () {
            var barChart = new Chart(this.$el.find('canvas'), {
                type: 'bar',
                data: {
                    labels: ["January", "February", "March", "April", "May", "June", "July"],
                    datasets: [
                        {
                            label: "My First dataset",
                            backgroundColor: [
                                'rgba(255, 99, 132, 0.2)',
                                'rgba(54, 162, 235, 0.2)',
                                'rgba(255, 206, 86, 0.2)',
                                'rgba(75, 192, 192, 0.2)',
                                'rgba(153, 102, 255, 0.2)',
                                'rgba(255, 159, 64, 0.2)'
                            ],
                            borderColor: [
                                'rgba(255,99,132,1)',
                                'rgba(54, 162, 235, 1)',
                                'rgba(255, 206, 86, 1)',
                                'rgba(75, 192, 192, 1)',
                                'rgba(153, 102, 255, 1)',
                                'rgba(255, 159, 64, 1)'
                            ],
                            borderWidth: 1,
                            data: [65, 59, 80, 81, 56, 55, 40],
                        }
                    ]
                }
            });
        },

        drawPdf: function () {

        }
    });

    local.AllCustomersWidget = instance.Widget.extend({
        template: 'AllCustomers',
        customers: [],
        fields: ['name'],
        domain: [['active', '=', true]],
        init: function (parent) {
            this._super(parent);
        },
        start: function () {
            var self = this;
            this.getCustomers().then(function (customers) {

                self.customers = customers;
            });
        },
        getCustomers: function () {
            var Customer = new instance.web.Model('res.partner');
            return Customer.query(this.fields).filter(this.domain).all();
        }
    });

    local.ReportInvoiceUtilityWidget = instance.Widget.extend({
         template: 'ReportInvoiceUtility',
         invoices: [],
         invoiceLines: [],
         productProduct:[],
         Currency:[],
         rowsDate :[],
         rowOrigin:[],
         accountJournal:[],

        events:{
          'click #toolbar > button' : 'clickOnAction',
          'change #current-journal': 'fectSearch',
          'change #from' : 'fectSearch',
          'change #to': 'fectSearch',
          'click #volver_btn': 'volver',
        },
        init : function(parent){
          this._super(parent);
        },
        start: function () {
          this.fecthFecha();
          this.submitForm();
        },
        // volver
        volver: function(){
          this.$el.find('#volver').empty();
          this.$el.find('.bootstrap-table').show({
              effect: 'drop',
              direction: 'down',
              duration: 200,
          });
        },
        // Cansultar
        submitForm: function () {
            var self = this;
            this.fetchCurency().then(function(Currency) {
                self.Currency = Currency;
                return Currency;
            }).then(function (Currency) {
                return self.fetchJournal();
            }).then(function (journal) {
                self.accountJournal =journal;
                self.$el.find('#current-journal').append('<option value="9999999">TODAS LAS SUC.</option>');
                _.each(journal, function (item) {
                  self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                return self.fetchInvoiceV2();
            }).then(function (invoices){
                self.invoices = invoices;
                return self.fetchInvoiceLine(invoices);
            }).then(function (invoiceLines) {
                self.invoiceLines = invoiceLines;
                return self.fecthProduct(invoiceLines);
            }).then(function(productProduct){
                self.productProduct = productProduct;
                return self.invoice_Currency();
            });
            return false;
        },
        // Fecha
        fecthFecha: function() {
            var to;
            var dateFormat1 = "mm/dd/yy",
              from = $( "#from" )
                .datepicker({
                  dateFormat: "dd/mm/yy",
                  changeMonth: true,
                  numberOfMonths: 1,
                })
                .on( "change", function() {
                  to.datepicker( "option", "minDate", getDate(this), "dd/mm/yyyy");
                });
              to = $( "#to" ).datepicker({
                dateFormat: "dd/mm/yy",
                defaultDate: "+7d",
                changeMonth: true,
                numberOfMonths: 1,
              })
              .on( "change", function() {
                from.datepicker( "option", "maxDate", getDate(this));
              });

            function getDate( element ) {
              var fechaSel =element.value.split('/');
              var date;
              try {
                date = $.datepicker.parseDate( dateFormat1, (fechaSel[1]+"/"+fechaSel[0]+"/"+fechaSel[2]));
              } catch( error ) {
               date = null;
              }
              return date;
            }
          },
        // Buscar Diario
        fetchJournal: function () {
          var self = this;
          var defer = $.Deferred();
            var Journal = new instance.web.Model('account.journal');
            Journal.query(['id', 'name']).filter([['type', '=', 'sale'], ['active', '=', true]]).all().then(function (results) {
                defer.resolve(results);
              });
              return defer;

        },
        // Buscar Cambio de Monedas USD,PYG,ARG,BRL
        fetchCurency: function () {
            var defer = $.Deferred();
            var currency_Rate = new instance.web.Model('res.currency.rate');
            var fields = ['id', 'name', 'currency_id', 'rate', 'create_date'];
            var domain = [['currency_id', '=', [166 , 20, 7, 3]]];
            currency_Rate.query(fields).filter(domain).all().then(function (results) {
              defer.resolve(results);
            });
            return defer;
          },
        // Invoice (FACTURAS)
        fetchInvoiceV2: function () {
            var filter ="[['state', '=',['open','paid']],['type', '=', 'out_invoice']";
            var journal_ids = _.flatten(_.map(this.accountJournal, function (item) {
              return item.id;
            }));

            if (journal_ids){
                filter=filter.concat(",['journal_id', '=',["+journal_ids+"]]");
            }
            filter=filter.concat("]");
            var field =['id', 'type', 'number', 'origin', 'state', 'journal_id', 'currency_id', 'invoice_line','date_invoice'];
            var defer = $.Deferred();
            var Invoice = new instance.web.Model('account.invoice');
            Invoice.query(field).filter(filter).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },
        // Invoice line (Linea de Factura)
        fetchInvoiceLine: function (invoices) {
          var defer = $.Deferred();
          var linesIds = _.flatten(_.map(invoices, function (item) {
            return item.invoice_line;
          }));
          var InvoiceLine = new instance.web.Model('account.invoice.line');
          InvoiceLine.query(['id', 'quantity', 'price_unit', 'discount', 'name', 'product_id', 'origin','invoice_id']).filter([['id', 'in', linesIds]]).all().then(function (results) {
            defer.resolve(results)
          });
          return defer;
        },
        // Product Product
        fecthProduct: function(invoiceLines){
          var defer = $.Deferred();
          var porductIDS = _.flatten(_.map(invoiceLines, function (item) {
            return item.product_id[0];
          }));
          var ProductProdcut =  new instance.web.Model('product.product');
          var fields = ['id', 'default_code', 'name_template', 'factory_code', 'factory_reference', 'factory_barcode', 'standard_price','type'];
          ProductProdcut.query(fields).filter([['id', 'in', porductIDS]]).all().then(function (results) {
            defer.resolve(results)
          });
          return defer;
        },
        // Obtener Monedas de la Factura
        getCutrrency: function (id){
          return _.find(this.Currency,function (curr) {
              return _.contains(curr.currency_id,id);
            });
        },
        // Actualizar cambio de las moneda de Factura
        invoice_Currency: function(){
          for (var i = 0; i < this.invoices.length; i++) {
            var currency_new;
            var item = this.invoices[i];
            var id = item.currency_id[0];
            currency_new = this.getCutrrency(id);
            if (!currency_new){
              currency_new={};
              currency_new.rate=1;
            }
            this.invoices[i].rate=(currency_new.rate);
          }
          return this.fectUtility();
        },
        // Obtener la Detalles de la Factura
        getInvoice: function (id_line){
          return _.find(this.invoices, function (inv) {
              return _.contains(inv.invoice_line, id_line);
            });
          },
        // Obtener las lineas de las Facturas
        getProduct: function(pro_id){
          return _.find(this.productProduct, function(prod){
            return _.contains(pro_id, prod.id);
          });
        },
        // unir los objetos
        fectUtility: function(){
          var data=[];
          var item;
          var invoice;
          var producto;

          for (var i = 0; i < this.invoiceLines.length; i++) {
            item = this.invoiceLines[i];
            invoice = this.getInvoice(item.id);
            producto =this.getProduct(item.product_id);
            if (!producto){
              producto={};
              producto.standard_price=0;
            }
            if (producto.type =="product"){
                data.push({number : (invoice.number),
                       name : (item.name),
                       quantity : accounting.formatNumber((item.quantity),0, ".", ","),
                       price_unity : accounting.formatNumber((item.price_unit / invoice.rate),2, ".", ","),
                       standar_price : accounting.formatNumber((producto.standard_price),2, ".", ","),
                       price_tot : accounting.formatNumber((item.quantity * (item.price_unit / invoice.rate)),2, ".", ","),
                       standar_tot : accounting.formatNumber((item.quantity * producto.standard_price),2, ".", ","),
                       utility : accounting.formatNumber(((item.quantity * (item.price_unit / invoice.rate)) - (item.quantity * producto.standard_price)),2, ".", ","),
                       journal_id :(invoice.journal_id[0]),
                       journal_name :(invoice.journal_id[1]),
                       date_invoice : (invoice.date_invoice),
                     });
            }
          }
          this.rowsDate=data;
          this.rowOrigin=data;
          this.loadTable(data)
        },
        // Buscar
        fectSearch: function(){
          var self = this;
          var desde =this.$el.find('#from').val();
          var hasta =this.$el.find('#to').val();
          var suc =this.$el.find('#current-journal').val();
          self.rowsDate=self.rowOrigin;
            if (suc != 9999999){
              self.rowsDate=_.filter(self.rowsDate, function (inv){ return inv.journal_id == suc});
            }
            if (desde){
              var date= desde.split('/')
              self.rowsDate=_.filter(self.rowsDate, function (inv){
                return inv.date_invoice >= (date[2]+"-"+date[1]+"-"+date[0])});
            }
            if (hasta){
              var date= hasta.split('/')

              self.rowsDate=_.filter(self.rowsDate, function (inv){
                return inv.date_invoice <= (date[2]+"-"+date[1]+"-"+date[0])});
            }
            self.reloadTable(self.rowsDate);
        },
        // cargara la tabla
        loadTable:function(rowsTable){
            var table = this.$el.find('#table');
            table.bootstrapTable({data : rowsTable});
        },
        // Actualizar la Tabla
        reloadTable:function(rowsTable){
            var table = this.$el.find('#table');
            table.bootstrapTable('load' ,rowsTable);
        },
        // imprimir PDF
        clickOnAction: function (e) {
            var action = this.$el.find(e.target).val();
            var self = this;
            var getColumns=[];
            var rows=[];
            var table = this.$el.find("#table");
            var data2 = table.bootstrapTable('getVisibleColumns');
            if (action === 'pdf') {
              var dataNEW = _.map(data2, function (val){ return val.field});
              _.each(this.rowsDate,function (item){
                        rows.push(_.pick(item, dataNEW));
              });
              // Obtener los nombre de la Cabezera
              _.each(_.map(data2,function(val){return val}), function(item){
                 getColumns.push([{title: item.title, dataKey: item.field}]);
              });
              // Llamar al pdf
              this.drawPDF(_.flatten(getColumns),rows)
            }
            if (action === 'chart'){
                var suc =this.$el.find('#current-journal').val();
                if (suc == 9999999){
                    self.fectCharFilter();
                }else{
                  $("#dialog" ).dialog({
                      autoOpen: true,
                      resizable: false,
                      modal: true,
                      title: 'Atención',
                      open: function() {
                          $(this).html('Para Generar el Gráfico debes Seleccionar todas las Sucursales');
                      },
                      show: {
                          effect: "shake",
                          duration: 300
                      },
                      hide: {
                          effect: "fade",
                          duration: 300
                      },
                      buttons: {
                          Aceptar: function() {
                              $(this).dialog('close');
                          }
                      }
                  });
                }
            }
        },
        // Generar pdfDoc
        drawPDF: function (getColumns,rows) {
            var self = this;
            var rowsPdf=[];
            var sucusal = this.sucDescrip = this.$el.find('#current-journal option:selected').text();
            var desde =(this.$el.find('#from').val());
            var hasta =(this.$el.find('#to').val());
            var totalPagesExp = "{total_pages_count_string}";
            var pdfDoc = new window.jsPDF();

            // rows=this.rowsDate;
            var quantity=_.reduce(_.map(rows,function(item){
               var valor=0;
                if (item.quantity){valor = parseFloat(((item.quantity.replace(".","")).replace(",",".")))} return valor}), function(memo, num){ return memo + num; },0);
            var precio_unit=_.reduce(_.map(rows,function(item){
                var valor =0;
                if (item.price_unity){valor=parseFloat(((item.price_unity.replace(".","")).replace(",",".")))} return valor}), function(memo, num){ return memo + num; },0);
            var precio_cost=_.reduce(_.map(rows,function(item){
                var valor=0;
                if(item.standar_price){valor=parseFloat(((item.standar_price.replace(".","")).replace(",",".")))} return valor}), function(memo, num){ return memo + num;},0);
            var tot_unit=_.reduce(_.map(rows,function(item){
                var valor=0;
                if (item.price_tot){valor=parseFloat(((item.price_tot.replace(".","")).replace(",",".")))}return valor}), function(memo, num){ return memo + num; },0);
            var tol_cost=_.reduce(_.map(rows,function(item){
                var valor=0;
                if (item.standar_tot){valor=parseFloat(((item.standar_tot.replace(".","")).replace(",",".")))} return valor }), function(memo, num){ return memo + num; },0);
            var utility=_.reduce(_.map(rows,function(item){
                var valor=0;
                if (item.utility){valor=parseFloat(((item.utility.replace(".","")).replace(",",".")))}return valor }), function(memo, num){ return memo + num; },0);

            rowsPdf=rows;

            rowsPdf.push({ number : "  ",
                        name : "TOTAL  USD  ",
                        quantity: accounting.formatNumber(quantity,0, ".", ","),
                        price_unity : accounting.formatNumber(precio_unit,2, ".", ","),
                        standar_price : accounting.formatNumber(precio_cost,2, ".", ","),
                        price_tot : accounting.formatNumber(tot_unit,2, ".", ","),
                        standar_tot : accounting.formatNumber(tol_cost,2, ".", ","),
                        utility : accounting.formatNumber(utility,2, ".", ",")
                    });

            rowsPdf.unshift({ number : "  ",
                        name : "TOTAL  USD  ",
                        quantity: accounting.formatNumber(quantity,0, ".", ","),
                        price_unity : accounting.formatNumber(precio_unit,2, ".", ","),
                        standar_price : accounting.formatNumber(precio_cost,2, ".", ","),
                        price_tot : accounting.formatNumber(tot_unit,2, ".", ","),
                        standar_tot : accounting.formatNumber(tol_cost,2, ".", ","),
                        utility : accounting.formatNumber(utility,2, ".", ",")
                    });

            pdfDoc.autoTable(getColumns, rowsPdf, {
                styles: { overflow: 'linebreak', fontSize: 8, columnWidth: 'wrap'},
                columnStyles: {
                              number: {fontStyle: 'bold'},
                              name :{columnWidth: '10px'},
                              quantity :{halign:'right' },
                              price_unity : {halign:'right' },
                              standar_price : {halign:'right' },
                              price_tot : {halign:'right' },
                              standar_tot : {halign:'right' },
                              utility : {halign:'right'},
              },
                margin: { top: 16, horizontal: 7},

                addPageContent: function (data) {
                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Análisis de Utilidad '+ sucusal, data.settings.margin.left, 10);

                    if(desde.length > 0 || hasta.length > 0){
                      var fecha='';
                      if(desde){
                        fecha=fecha.concat(' Desde '+desde);
                      }
                      if (hasta){
                        fecha=fecha.concat(' Hasta '+hasta);
                      }
                        pdfDoc.setFontSize(10);
                        pdfDoc.setFontStyle('bold');
                        pdfDoc.setTextColor(40)
                        pdfDoc.text(fecha, data.settings.margin.left,14);
                    }
                    // FOOTER
                    var str = "Pagina  " + data.pageCount;
                    // Total page number plugin only available in jspdf v1.0+
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp;
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(str, data.settings.margin.left, pdfDoc.internal.pageSize.height - 5);
                }
            });

            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
            pdfDoc.save('Analisis de utilidad.pdf')
        },
        // Chart Filter
        fectCharFilter: function(){
          var self = this;
          var dataBody=[];
          var dataHeader=[];
          _.each(self.accountJournal, function(journal){
            dataHeader.push(journal.name);
            var utility=_.reduce(_.map(_.filter(self.rowsDate, function (inv){ return inv.journal_id == journal.id}),function(item){
              return parseFloat(((item.utility.replace(".","")).replace(",",".")))}), function(memo, num){ return memo + num; },0);
            dataBody.push(accounting.toFixed((utility),2));
          });
          var selector ="<button type='button' class='oe_button oe_form_button oe_highlight' id='volver_btn' name='volver_btn'><span>Atras</span></button>";

          this.$el.find('#volver').append(selector);

          this.$el.find('.bootstrap-table').hide({
              effect: 'drop',
              direction: 'up',
              duration: 200,
              complete: function () {
                self.drawChart(dataHeader,dataBody);
              }
          });
        },
        // Chart
        drawChart: function (dataHeader,dataBody) {
            var barChart = new Chart(this.$el.find('canvas'), {
              // type:"doughnut",

                type: 'bar',
                data: {
                    labels: dataHeader,
                    datasets: [
                        {
                            label: "Utilidad USD",
                            backgroundColor: [
                                'rgba(255, 99, 132, 0.2)',
                                'rgba(54, 162, 235, 0.2)',
                                'rgba(255, 206, 86, 0.2)',
                                'rgba(75, 192, 192, 0.2)',
                                'rgba(153, 102, 255, 0.2)',
                            ],
                            borderColor: [
                                'rgba(255,99,132,1)',
                                'rgba(54, 162, 235, 1)',
                                'rgba(255, 206, 86, 1)',
                                'rgba(75, 192, 192, 1)',
                                'rgba(153, 102, 255, 1)',
                            ],
                            borderWidth: 1,
                            data: dataBody,
                        }
                    ]
                }
            });
        },

    });

    local.ReportProductUtilityWidget = instance.Widget.extend({
        template: 'ReportProductUtility',
        // Global Variable
        Currency:[],
        Journal:[],
        Invoice:[],
        InvoiceLine:[],
        Product:[],
        ProductPriceHistory:[],
        ProductAttribute:[],
        utility:[],

        events:{

        },
        init: function(parent){
          this._super(parent);
        },
        start:  function(){
            this.fecthFecha();
            this.fecthInitial();
        },
        // Fecha
        fecthFecha: function() {
            var to;
            var dateFormat1 = "mm/dd/yy",
              from = $( "#from" )
                .datepicker({
                  dateFormat: "dd/mm/yy",
                  changeMonth: true,
                  numberOfMonths: 1,
                })
                .on( "change", function() {
                  to.datepicker( "option", "minDate", getDate(this), "dd/mm/yyyy");
                });
              to = $( "#to" ).datepicker({
                dateFormat: "dd/mm/yy",
                defaultDate: "+7d",
                changeMonth: true,
                numberOfMonths: 1,
              })
              .on( "change", function() {
                from.datepicker( "option", "maxDate", getDate(this));
              });

            function getDate( element ) {
              var fechaSel =element.value.split('/');
              var date;
              try {
                date = $.datepicker.parseDate( dateFormat1, (fechaSel[1]+"/"+fechaSel[0]+"/"+fechaSel[2]));
              } catch( error ) {
               date = null;
              }
              return date;
            }
          },
        // Consulata inicial
        fecthInitial: function(){
            var self= this;
            this.fetchCurency().then(function(Currency){
                self.Currency=Currency;
                return Currency;
            }).then(function(Currency){
                return self.fetchJournal();
            }).then(function(Journal){
                self.Journal=Journal;
                self.$el.find('#current-journal').append('<option value="9999999">TODAS LAS SUC.</option>');
                _.each(Journal, function (item) {
                    self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                return self.fetchInvoice();
            }).then(function(Invoice){
                  self.Invoice= Invoice;
                  return self.fetchInvoiceLine(Invoice);
            }).then(function(InvoiceLine){
                  self.InvoiceLine = InvoiceLine;
                  return self.fecthProduct(InvoiceLine);
            }).then(function(Product){
                  self.Product=Product;
                  return self.fecthProductPriceHistory(Product);
            }).then(function(ProductPriceHistory){
                  self.ProductPriceHistory= ProductPriceHistory;
                  return self.fecthProductAttribute();
            }).then(function(ProductAttribute){
                self.ProductAttribute =ProductAttribute;
                return self.callFuntions();
            });
            return false;
        },
        // Buscar Cambio de Monedas USD,PYG,ARG,BRL
        fetchCurency: function () {
            var defer = $.Deferred();
            var currency_Rate = new instance.web.Model('res.currency.rate');
            var fields = ['id', 'name', 'currency_id', 'rate', 'create_date'];
            var domain = [['currency_id', '=', [166 , 20, 7, 3]]];
            currency_Rate.query(fields).filter(domain).all().then(function (results) {
              defer.resolve(results);
            });
            return defer;
          },
        // Buscar Diario
        fetchJournal: function () {
            var self = this;
            var defer = $.Deferred();
            var Journal = new instance.web.Model('account.journal');
            Journal.query(['id', 'name']).filter([['type', '=', 'sale'], ['active', '=', true]]).order_by('id').all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },
        // Invoice (FACTURAS)
        fetchInvoice: function () {
            var filter ="[['state', '=',['open','paid']],['type', '=', 'out_invoice']";
            var journal_ids = _.flatten(_.map(this.Journal, function (item) {
              return item.id;
            }));
            if (journal_ids){
                filter=filter.concat(",['journal_id', '=',["+journal_ids+"]]");
            }
            filter=filter.concat("]");
            var field =['id', 'type', 'number', 'origin', 'state', 'journal_id', 'currency_id', 'invoice_line','date_invoice'];
            var defer = $.Deferred();
            var Invoice = new instance.web.Model('account.invoice');
            Invoice.query(field).filter(filter).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },
        // Invoice line (Linea de Factura)
        fetchInvoiceLine: function (invoices) {
            var defer = $.Deferred();
            var linesIds = _.flatten(_.map(invoices, function (item) {
              return item.invoice_line;
            }));
            var InvoiceLine = new instance.web.Model('account.invoice.line');
            InvoiceLine.query(['id', 'quantity', 'price_unit', 'discount', 'name', 'product_id', 'origin','invoice_id']).filter([['id', 'in', linesIds]]).all().then(function (results) {
              defer.resolve(results)
            });
            return defer;
        },
        // Product Product
        fecthProduct: function(invoiceLines){
            var defer = $.Deferred();
            var porductIDS = _.flatten(_.map(invoiceLines, function (item) {
              return item.product_id[0];
            }));
            var ProductProdcut =  new instance.web.Model('product.product');
            var fields = ['id', 'default_code', 'name_template', 'factory_code', 'factory_reference', 'factory_barcode', 'standard_price','type', 'product_tmpl_id','attribute_value_ids'];
            ProductProdcut.query(fields).filter([['id', 'in', porductIDS]]).all().then(function (results) {
              defer.resolve(results)
            });
            return defer;
        },
        // Product price history
        fecthProductPriceHistory: function(ProductProduct){
            var defer = $.Deferred();
            var productotmp=_.flatten(_.map(ProductProduct, function(item){
              return item.product_tmpl_id[0];
            }));
            var fields = ['id', 'cost', 'product_template_id', 'company_id'];
            var productPrice = new instance.web.Model('product.price.history');
            productPrice.query(fields).filter([['product_template_id','in',productotmp]]).all().then(function(results){
              defer.resolve(results);
            });
            return defer;
        },
        // Product price history
        fecthProductAttribute: function(){
            var defer = $.Deferred();
            var fields = ['id', 'name'];
            var productPrice = new instance.web.Model('product.attribute.value');
            productPrice.query(fields).filter().all().then(function(results){
              defer.resolve(results);
            });
            return defer;
        },
        // Llammar metodos
        callFuntions: function(){
            var self = this;
            self.fecthInvoiceCurrency();
            self.fecthLineRate();
            self.fecthUtilityProduct();
        },
        // Obtener Monedas de la Factura
        getCutrrency: function (id){
              return _.find(this.Currency,function (curr) {return _.contains(curr.currency_id,id)});
        },
        // ADD  cambio en invoice
        fecthInvoiceCurrency: function(){
            for (var i = 0; i < this.Invoice.length; i++) {
              var currency_new;
              var item = this.Invoice[i];
              var id = item.currency_id[0];
              currency_new = this.getCutrrency(id);
              if (!currency_new){
                currency_new={};
                currency_new.rate=1;
              }
              this.Invoice[i].rate=(currency_new.rate);
            }
        },
        // ADD Rate en linea de factura
        fecthLineRate: function(){
            var item;
            var invoice_rate;
            for (var i = 0; i < this.InvoiceLine.length; i++) {
              item = this.InvoiceLine[i];
              invoice_rate= this.getInvoiceRate(item.id);
              if (!invoice_rate){
                  invoice_rate={};
                  invoice_rate.rate=1
              }
              this.InvoiceLine[i].rate=(invoice_rate.rate);
              this.InvoiceLine[i].journal_id =invoice_rate.journal_id
              this.InvoiceLine[i].currency_id =invoice_rate.currency_id
              this.InvoiceLine[i].date_invoice =invoice_rate.date_invoice
            }
        },
        // Leer rate de factura
        getInvoiceRate: function(ids){
          return _.find(this.Invoice,function (inv) {return _.contains(inv.invoice_line,ids)});
        },
        // Obtener la Detalles de la Factura
        getInvoiceLine: function (id_product){
            var line={};
            var cat = 0;
            var price = 0;
            cat=(_.reduce(_.map(_.filter(this.InvoiceLine, function(item){return item.product_id[0] === id_product}),function (item){
                                  return item.quantity}), function(memo, num){ return memo + num; },0));
            price=(_.reduce(_.map(_.filter(this.InvoiceLine, function(item){return item.product_id[0] === id_product}),function (item){
                                  return ((item.quantity*item.price_unit) / item.rate);}), function(memo, num){ return memo + num; },0));
            // Cargar Objeto;
            line.quantity= cat;
            line.price_unit = price;
            line.price_prome =(price/cat);
            return line;
          },
          //Obtener attribute
          getAttributeName: function(id_prodcut){
              return _.filter(this.ProductAttribute, function(item){return item.id === id_prodcut}).shift();
          },
          getProductPriceHistory:function(id_tmpl){
              var cant;
              var standar = 0;
              var history={};
              // Retirnar la Cantidad de Registro  y la sumatoria de coste
              cant=_.countBy(this.ProductPriceHistory, function(item){return item.product_template_id[0] == id_tmpl ? 'even': 'odd'});
              standar=(_.reduce(_.map(_.filter(this.ProductPriceHistory, function(item){return item.product_template_id[0] === id_tmpl}),function (item){
                return item.cost}), function(memo, num){ return memo + num; },0));
              // Cargar el Objeto
              history.standar_price =standar;
              history.cant = cant.even;
              history.standar_pro=standar/cant.even;
              // Retornar Valor
              return history;

          },
        // Generar objeto principal
        fecthUtilityProduct: function(){
          var self = this;
          var item;
          var line;
          var attribute;
          var standarPrice;
          var datos=[];
            for (var i = 0; i < self.Product.length; i++) {
                item=self.Product[i];
                if (item.type =="product"){

                    line =self.getInvoiceLine(item.id);
                    if (!line){
                          line={};
                          line.quantity= 0;
                          line.price_unit = 0;
                          line.price_prome =0;
                    }
                    attribute = self.getAttributeName(item.attribute_value_ids[0]);
                    if (!attribute){
                          attribute={};
                          attribute.id = 0;
                          attribute.name = " ";
                    }
                    standarPrice = self.getProductPriceHistory(item.product_tmpl_id[0]);
                    if (!standarPrice){
                          standarPrice={};
                          standarPrice.standar_price = 0;
                          standarPrice.cant = 0;
                          standarPrice.standar_pro = 0;
                    }

                    self.utility.push({ name : item.name_template+" "+attribute.name,
                                        default_code:item.default_code,
                                        factory_barcode : item.factory_barcode,
                                        quantity : line.quantity,
                                        price_unity :line.price_unit,
                                        standar_price : standarPrice.standar_price,
                                        price_pro : line.price_prome,
                                        standar_pro : standarPrice.standar_pro,
                                        utility : (line.price_unit - standarPrice.standar_price)
                                        // journal_id :,
                                        // currency_id :,
                                        // date_invoice :
                                    });
              }

            }
            // default_code : item.default_code,
            // attribute_value_ids : item.attribute_value_ids,
            // name_template : item.name_template,
            // factory_code : item.factory_code,
            // factory_reference : item.factory_reference,
            // factory_barcode : item.factory_barcode,
            // quantity : line.quantity,
            // price_unit_tot : line.price_unit,
            // price_unit_prome : line.price_prome,
            // product_tmpl_id: item.product_tmpl_id

            // name : item.name_template+" "+item.attribute_value_ids
            // quantity : line.quantity
            // price_unity :line.price_unit
            // standar_price : 0
            // price_pro : line.price_prome
            // standar_pro : 0
            // utility : 0
            // //
            //

            // standarPrice = self.getProductPriceHistory(7834);

            self.loadTable(self.utility)
            // 'id', 'quantity', 'price_unit', 'discount', 'name', 'product_id', 'origin','invoice_id'
            // 'id', 'default_code', 'name_template', 'factory_code', 'factory_reference', 'factory_barcode', 'standard_price','type', 'product_tmpl_id'

        },
        // cargara la tabla
        loadTable:function(rowsTable){
            var table = this.$el.find('#table');
            table.bootstrapTable({data : rowsTable});
        },


    });

    local.ReportResumenIngresoWidget = instance.Widget.extend({
        template :'ReportResumenIngreso',
        accountVoucher:[],
        resCurrency:[],
        accountJournal:[],
        dataVoucher:[],
        currencyRate:[],

        events:{
          'click #toolbar > button' : 'clickOnAction',
          'change #current-journal': 'fectSearch',
          'change #current-currency': 'fectSearch',
          'change #from' : 'fectSearch',
          'change #to': 'fectSearch',
          'click #volver_btn': 'volver',
        },

        init:function(parent){
            this._super(parent);
        },
        start: function(){
            var self = this;
            self.fecthFecha();
            self.fecthInitial();
        },
        // Fecha
        fecthFecha: function() {
            var to;
            var dateFormat1 = "mm/dd/yy",
                from = $( "#from" ).datepicker({
                    dateFormat: "dd/mm/yy",
                    changeMonth: true,
                    numberOfMonths: 1,
                })
                .on( "change", function() {
                    to.datepicker( "option", "minDate", getDate(this), "dd/mm/yyyy");
                });
                to = $( "#to" ).datepicker({
                    dateFormat: "dd/mm/yy",
                    defaultDate: "+7d",
                    changeMonth: true,
                    numberOfMonths: 1,
                })
                .on( "change", function() {
                    from.datepicker( "option", "maxDate", getDate(this));
                });
            function getDate( element ) {
                var fechaSel =element.value.split('/');
                var date;
                try {
                    date = $.datepicker.parseDate( dateFormat1, (fechaSel[1]+"/"+fechaSel[0]+"/"+fechaSel[2]));
                } catch( error ) {
                    date = null;
                }
              return date;
            }
         },
        //  Metodo inicial
        fecthInitial: function(){
            var self = this;
            self.fecthJournalStore().then(function(accountJournal){
                self.accountJournal=accountJournal;
                return accountJournal;
            }).then(function(accountJournal){
                self.$el.find('#current-journal').append('<option value="9999999">Todas las SUC.</option>');
                _.each(accountJournal,function(item){
                    self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                return self.fecthCurrency();
            }).then(function(resCurrency){
                self.$el.find('#current-currency').append('<option value="999">Todas las Monedas</option>');
                _.each(resCurrency,function(item){
                    self.$el.find('#current-currency').append('<option value="'+item.id+'">'+item.name +' '+item.symbol+'</option>');
                });
                self.resCurrency =resCurrency;
                return self.fecthCurrencyRate();
            }).then(function(currencyRate){
                self.currencyRate =currencyRate;
                return self.fecthVoucher();
            }).then(function(accountVoucher){
                self.accountVoucher =accountVoucher;
                return self.fecthDataVoucher(self.accountVoucher,self.accountJournal);
            });
            return false;
        },
        // Journal
        fecthJournalStore: function(){
            var self = this;
            var defer = $.Deferred();
            var journal = new instance.web.Model('res.store');
            var field=['id', 'name','out_invoice_id','journal_ids'];
            journal.query(field).order_by('id').all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        // Moneda
        fecthCurrency:function(){
            var self = this;
            var defer = $.Deferred();
            var currency = new instance.web.Model('res.currency');
            var field = ['id', 'name', 'symbol'];
            var domain = [['active','=', true]];
            currency.query(field).filter(domain).order_by('id').all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        // Cambio de la moneda
        fecthCurrencyRate:function(){
            var defer = $.Deferred();
            var currency_Rate = new instance.web.Model('res.currency.rate');
            var fields = ['id', 'name', 'currency_id', 'rate', 'create_date'];
            var domain = [['currency_id', '=', [166 , 20, 7, 3]]];
            currency_Rate.query(fields).filter(domain).all().then(function (results) {
              defer.resolve(results);
            });
            return defer;
        },
        // Voucher -
        fecthVoucher:function(){
            var self= this;
            var defer = $.Deferred();
            var voucher = new instance.web.Model('account.voucher');
            var field = ['id', 'reference', 'number', 'partner_id', 'payment_rate_currency_id', 'currency_id', 'company_id',' state',' pre_line', 'payment_rate', 'type', 'date', 'name', 'journal_id', 'amount'];
            var domain =[['type', '=', 'receipt']];
            voucher.query(field).filter(domain).order_by('id').all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        // Verificar Valor null
        valorNull:function(dato){
            var valor ="";
            if (dato){
                if(dato == true && typeof dato == 'boolean'){
                    valor="X";
                }else{
                    valor=dato;
                }
            }
            return valor;
        },
        // Join object
        fecthDataVoucher:function(objVoucher,objJournal){
            var self=this;
            var item;
            var journal;
            var voucherLine;
            var voucherItem;//Contenido del voucher
            var sumaAmount; //Guardar la suma de los pagos
            var voucherObject=[];
            var voucherObjectItem=[];
            var cutrrencyRate; //Valor del cambio
            var total=0;
            var sumaAmountTot=0;
            var  itemVoucher;
            for (var i = 0; i < objJournal.length; i++) {
                voucherObjectItem=[];
                journal=objJournal[i];
                //Generar la Cabezera con el nombre de la sucursal
                for (var f = 0; f < journal.journal_ids.length; f++) {
                    voucherLine = journal.journal_ids[f];
                    voucherItem = self.getVoucherjournal(objVoucher,voucherLine)
                    if (voucherItem.length > 0){
                        sumaAmount=_.reduce(_.map(voucherItem,function(item){return item.amount}), function(memo, num){ return memo + num; },0);
                        itemVoucher = voucherItem.shift();
                        cutrrencyRate=self.getCutrrencyRate(itemVoucher.currency_id[0]);
                        if (!cutrrencyRate){
                            cutrrencyRate={};
                            cutrrencyRate.rate=1;
                        }
                        // Guardar item
                        voucherObjectItem.push({    journal : " ",
                                                method  :self.valorNull(itemVoucher.journal_id[1]),
                                                amount  : accounting.formatNumber(self.valorNull(sumaAmount),2, ".", ","),
                                                currency_name : self.valorNull(itemVoucher.currency_id[0]),
                                                currency_id : self.valorNull(itemVoucher.currency_id[1]),
                                                rate : cutrrencyRate.rate,
                                                amountBase : self.valorNull(sumaAmount / cutrrencyRate.rate),
                                                journal_id: journal.id,
                                                journal_name: journal.name,
                                                graficar: false
                                        })
                    }
                }
                sumaAmountTot=_.reduce(_.map(voucherObjectItem,function(item){return (item.amountBase)}), function(memo, num){ return memo + num; },0);
                total=total+sumaAmountTot;
                voucherObjectItem.push({journal : " ",
                                        method  :"Total Dolares",
                                        amount  : accounting.formatNumber(self.valorNull(sumaAmountTot),2, ".", ","),
                                        currency_name : "",
                                        currency_id : "",
                                        rate : "cutrrencyRate.rate",
                                        amountBase:"",
                                        journal_id: journal.id,
                                        journal_name: journal.name,
                                        graficar: true
                                });
                // Generarl la Cabezera
                voucherObjectItem.unshift({ journal : journal.name, method  :"", amount  :"", voucherLine_name :"", voucherLine_id :"",rate :"",amountBase :"",journal_id:journal.id, journal_name:journal.name, graficar:false});
                // Generar Objeto Principal
                voucherObject=voucherObject.concat(voucherObjectItem);
            }
            voucherObject.push({journal : " Total de Ingreso",
                                    method  :"",
                                    amount  : accounting.formatNumber(self.valorNull(total),2, ".", ","),
                                    currency_name : "",
                                    currency_id : "",
                                    rate : "",
                                    amountBase:"",
                                    journal_id: journal.id,
                                    journal_name: journal.name,
                                    graficar: false
                            });
            self.loadTable(voucherObject);
        },
        // Obtener Voucher
        getVoucherjournal:function(objVoucher,journal_id){
            return _.map(_.filter(objVoucher, function (inv){return inv.journal_id[0] === journal_id}),function(item){return item});
        },
        // Obtener Cambio
        getCutrrencyRate: function(currency_id){
            return _.filter(this.currencyRate, function(rate){return rate.currency_id[0] === currency_id}).shift();
        },
        // Generar la table
        loadTable:function(rowsTable){
            this.dataVoucher=rowsTable;
            var table = this.$el.find('#table');
            if( table.bootstrapTable('getData').length <= 1){
                table.bootstrapTable({data : rowsTable});
            }else{
                table.bootstrapTable('load' ,rowsTable);
            }
        },
        // Buscar
        fectSearch: function(){
            var self = this;
            var desde =this.$el.find('#from').val();
            var hasta =this.$el.find('#to').val();
            var journal =this.$el.find('#current-journal').val();
            var currency =this.$el.find('#current-currency').val();
            var newJournal= self.accountJournal; //copia del Diario
            var newVoucher= self.accountVoucher; //copia del Vouacher

            if (journal != 9999999){
                var botonChart =this.$el.find('#chart').attr("disabled", true);
                 newJournal=_.filter(newJournal, function (inv){ return inv.id == journal});
            }else {
                var botonChart =this.$el.find('#chart').attr("disabled", false);
            }

            if(currency != 999){
                 newVoucher=_.filter(newVoucher, function (inv){ return inv.currency_id[0] == currency});
            }

            if (desde){
                 var date= desde.split('/')
                 newVoucher=_.filter(newVoucher, function (inv){return inv.date >= (date[2]+"-"+date[1]+"-"+date[0])});
            }

            if (hasta){
                var date= hasta.split('/')
                newVoucher=_.filter(newVoucher, function (inv){return inv.date <= (date[2]+"-"+date[1]+"-"+date[0])});
           }
            self.fecthDataVoucher(newVoucher,newJournal);
        },
        // volver
        volver: function(){
          this.$el.find('#volver').empty();
          this.$el.find('#grafico').empty();
        //   this.$el.find('canvas').empty()
          this.$el.find('.bootstrap-table').show({
              effect: 'drop',
              direction: 'down',
              duration: 200,
          });
        },
        // Click pdf -Grafic
        clickOnAction: function (e) {
            var action = this.$el.find(e.target).val();
            var self = this;
            var getColumns=[];
            var rows=[];
            var table = this.$el.find("#table");
            var data2 = table.bootstrapTable('getVisibleColumns');
            if (action === 'pdf') {
              var dataNEW = _.map(data2, function (val){ return val.field});
              _.each(this.dataVoucher,function (item){
                        rows.push(_.pick(item, dataNEW));
              });
              // Obtener los nombre de la Cabezera
              _.each(_.map(data2,function(val){return val}), function(item){
                 getColumns.push([{title: item.title, dataKey: item.field}]);
              });
              // Llamar al pdf
              this.drawPDF(_.flatten(getColumns),rows)
            }
            if (action === 'chart'){
                var self = this;
                var objetChar;
                objetChar = _.filter(self.dataVoucher,function(item){return item.graficar === true});
                self.fectCharFilter(objetChar);
            }
        },
        // pdfDoc
        drawPDF:function(getColumns,rows){
            var self = this;
            var fechaActu= new Date();
            var sucusal = this.sucDescrip = this.$el.find('#current-journal option:selected').text();
            var desde =(this.$el.find('#from').val());
            var hasta =(this.$el.find('#to').val());
            var totalPagesExp = "{total_pages_count_string}";
            var pdfDoc = new window.jsPDF();

            pdfDoc.autoTable(getColumns, rows, {
                    styles: { overflow: 'linebreak', fontSize:10 , columnWidth: 'wrap'},
                   columnStyles:{ journal: {fontStyle: 'bold'},
                                  method :{columnWidth: '10px'},
                                  amount : {halign:'right'},
                                },
                   margin: { top: 16, horizontal: 7},
                addPageContent: function (data) {
                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Resumen de Ingreso de '+ sucusal, data.settings.margin.left, 10);
                    if(desde.length > 0 || hasta.length > 0){
                        var fecha='';
                        if(desde){
                            fecha=fecha.concat(' Desde '+desde);
                        }
                        if (hasta){
                            fecha=fecha.concat(' Hasta '+hasta);
                        }
                        pdfDoc.setFontSize(10);
                        pdfDoc.setFontStyle('bold');
                        pdfDoc.setTextColor(40)
                        pdfDoc.text(fecha, data.settings.margin.left,14);
                    }
                    // FOOTER
                    var str = "Pagina  " + data.pageCount;
                    // Total page number plugin only available in jspdf v1.0+
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp +"\n  Día de Expedición  "+fechaActu.getDate()+"/"+fechaActu.getMonth()+"/"+fechaActu.getFullYear();
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(str, data.settings.margin.left, pdfDoc.internal.pageSize.height - 5);
                }
            });
            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
           pdfDoc.save('Resumen de Ingreso.pdf');
        },
        // Char filter
        fectCharFilter: function(objetChar){
            var self = this;
            var dataBody=[];
            var dataHeader=[];
            // objetChar
            var canvas="<canvas id='graf_resume'></canvas>";
              this.$el.find('#grafico').append(canvas);
            _.each(objetChar,function(voucher){
                dataHeader.push(voucher.journal_name);
                dataBody.push(parseFloat(((voucher.amount.replace(".","")).replace(",","."))));
            });
          var selector ="<button type='button' class='oe_button oe_form_button oe_highlight' id='volver_btn' name='volver_btn'><span>Atras</span></button>";
          this.$el.find('#volver').append(selector);
          this.$el.find('.bootstrap-table').hide({
              effect: 'drop',
              direction: 'up',
              duration: 200,
              complete: function () {
                self.drawChart(dataHeader,dataBody);
              }
          });
        },
        //Chart
        drawChart: function (dataHeader,dataBody) {
            var barChart = new Chart(this.$el.find('#graf_resume'), {
                type: 'doughnut',//bar, doughnut
                data: {
                    labels: dataHeader,
                    datasets: [
                        {
                            labels: dataHeader,
                            backgroundColor: [
                                'rgba(255, 99, 132, 0.2)',
                                'rgba(54, 162, 235, 0.2)',
                                'rgba(255, 206, 86, 0.2)',
                                'rgba(75, 192, 192, 0.2)',
                                'rgba(153, 102, 255, 0.2)',
                            ],
                            borderColor: [
                                'rgba(255,99,132,1)',
                                'rgba(54, 162, 235, 1)',
                                'rgba(255, 206, 86, 1)',
                                'rgba(75, 192, 192, 1)',
                                'rgba(153, 102, 255, 1)',
                            ],
                            borderWidth: 1,
                            data: dataBody,
                        }
                    ]
                },
                options: {
                    maintainAspectRatio: false,
                    layout: {
                        padding: 30
                    }
                },
            });
        },
    });

    local.ReportStockLocationWidget = instance.Widget.extend({
        template : 'ReportStockLocation',
        stockLocation : [],
        stockQuant : [],
        productProduct : [],
        prodcut:[],

        events : {
            'click #toolbar > button' : 'clickOnAction',
            'change #current-location': 'fecthSearch',
        },
        init : function(parent){
            this._super(parent);
        },
        start : function(){
            var self = this;
            var dato=[];
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.prodcut});
            self.fecthInitial();
        },
        // Consulta Inicial
        fecthInitial: function(){
            var self = this;
            self.fecthLocation().then(function(stockLocation){
                self.stockLocation=stockLocation
                return stockLocation;
            }).then(function(stockLocation){
                self.$el.find('#current-location').append('<option value="9999999">Todas las Ubicación.</option>');
                _.each(stockLocation,function(item){
                    self.$el.find('#current-location').append('<option value="' + item.id + '">' + item.location_id[1]+" / "+item.name + '</option>');
                });
                return self.fecthStockQuant();
            }).then(function(stockQuant){
                self.stockQuant = stockQuant;
                return self.fecthProduct(stockQuant);
            }).then(function(productProduct){
                self.productProduct = productProduct;
                return self.fecthProducto(self.stockQuant, self.stockLocation);
            });
            return false;
        },
        // Ubicacion
        fecthLocation : function(){
            var self = this;
            var defer = $.Deferred();
            var location = new instance.web.Model('stock.location');
            var fields = ['id', 'name', 'company_id', 'location_id'];
            var domain =[['active', '=', true],['usage', '=', 'internal']];
            location.query(fields).filter(domain).order_by('id').all().then(function(results){
                defer.resolve(results);
            })
            return defer;
        },
        // quant
        fecthStockQuant : function(){
            var self = this;
            var defer = $.Deferred();
            var location = _.map(self.stockLocation,function(item){return item.id});
            var company_id =(_.map(self.stockLocation, function(item){return item.company_id[0]})).shift();
            var quant = new instance.web.Model('stock.quant');
            var fields = ['id', 'product_id', 'qty', 'cost','location_id'];
            var domain =[['company_id', '=', company_id],['location_id', '=',location]];
            quant.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            })
            return defer;
        },
        // ProductProduct
        fecthProduct: function(quant){
            var defer = $.Deferred();
            var porductIDS = _.flatten(_.map(quant, function (item) {
              return item.product_id[0];
            }));
            var ProductProdcut =  new instance.web.Model('product.product');
            var fields = ['id','name','name_template', 'standard_price','type','attribute_value_ids'];
            ProductProdcut.query(fields).filter([['id', 'in', porductIDS]]).all().then(function (results) {
              defer.resolve(results)
            });
            return defer;
        },
        // Union de Modulos
        fecthProducto : function(stockQuant,stockLocation){
            var self = this;
            var stock=[];
            var itemLocation;
            var itemProduct;
            var itemQuant;
            var productProduct;
            var cat = 0;
            for (var i = 0; i < stockLocation.length; i++) {
                itemLocation = stockLocation[i];
                productProduct = self.getProdcutoProduct(self.productProduct,stockQuant, itemLocation.id);
                for (var f = 0; f < productProduct.length; f++) {
                    itemProduct = productProduct[f];
                    itemQuant = self.getQuantProduct(itemLocation.id, itemProduct.id, stockQuant);
                    if (itemQuant.length >0){
                        cat = _.reduce(_.map(itemQuant,function(item){return item.qty}),function(mamo, num){return mamo + num},0);
                        quant=itemQuant.shift();
                        stock.push({prodcut : quant.product_id[1],
                                    qty : cat,
                                    location :(itemLocation.location_id[1]+" / "+itemLocation.name)});
                    }
                }
            }
            self.loadTable(stock);
        },
        // Obtener Producto Por quant y locations
        getProdcutoProduct: function(productProduct, stockQuant, location_id){
            var self = this;
            var product_ids= _.flatten(_.map(_.filter(stockQuant, function(item){return item.location_id[0] === location_id}),function(map){return map.product_id[0]}));
            return _.filter(productProduct,function(prod){return _.contains(product_ids, prod.id)});
        },
        // Obtener  Qaunt  por productos
        getQuantProduct: function(location_id, product_id, quantObjs){
            var self = this;
            var quantProdcut = quantObjs;
            if (location_id){
                quantProdcut = _.filter(quantProdcut, function(item){return item.location_id[0] === location_id});
            }
            if (product_id){
                quantProdcut = _.filter(quantProdcut, function(item){return item.product_id[0] === product_id});
            }
            return quantProdcut;
        },
        // Buscar
        fecthSearch: function(){
            var self = this;
            var location =this.$el.find('#current-location').val();
            var locationObjs = self.stockLocation;
            var quantObjs = self.stockQuant;
            if (location != 9999999){
                 locationObjs=_.filter(locationObjs, function (inv){ return inv.id == location});
                 quantObjs=_.filter(quantObjs, function (inv){ return inv.location_id[0] == location});
            }
            self.fecthProducto(quantObjs,locationObjs)
        },
        // Generar la table
        loadTable:function(rowsTable){
            var self = this;
            this.prodcut=rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load' ,rowsTable);
        },
        // Click pdf -Grafic
        clickOnAction: function (e) {
            var self = this;
            var action = self.$el.find(e.target).val();
            var getColumns=[];
            var rows=[];
            var table = self.$el.find("#table");
            var data2 = table.bootstrapTable('getVisibleColumns');
            if (action === 'pdf') {
                var dataNEW = _.map(data2, function (val){ return val.field});
                _.each(self.prodcut,function (item){
                    rows.push(_.pick(item, dataNEW));
                });
              // Obtener los nombre de la Cabezera
                _.each(_.map(data2,function(val){return val}), function(item){
                    getColumns.push([{title: item.title, dataKey: item.field}]);
                });
                self.drawPDF(_.flatten(getColumns),rows)
            }
        },
        // pdfDoc
        drawPDF:function(getColumns,rows){
            var self = this;
            var fechaActu= new Date();
            var location = this.sucDescrip = this.$el.find('#current-location option:selected').text();
            var totalPagesExp = "{total_pages_count_string}";
            var pdfDoc = new jsPDF();
            pdfDoc.autoTable(getColumns, rows, {
                    styles: { overflow: 'linebreak', fontSize:8 , columnWidth: 'wrap'},
                   columnStyles:{
                                    prodcut :{columnWidth: '8px'},
                                   location :{columnWidth: '8px'},
                                   qty : {halign:'center'},
                                },
                   margin: { top: 16, horizontal: 7},
                addPageContent: function (data) {
                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Listado de Stock Por '+ location, data.settings.margin.left, 10);
                    // FOOTER
                    var str = "Pagina  " + data.pageCount;
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp +"\n  Día de Expedición  "+fechaActu.getDate()+"/"+fechaActu.getMonth()+"/"+fechaActu.getFullYear();
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(str, data.settings.margin.left, pdfDoc.internal.pageSize.height - 5);
                }
            });
            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
           pdfDoc.save('Listado_de_Stock_Por_Ubicaion.pdf');
        }
    });

    instance.web.client_actions.add('eiru_reporting.action_report', 'instance.eiru_reporting.ReportingWidget');
}
